/* searchz2.c @T[`UR */
#include <xsp2lib.h>

#include "../main.h"
#include "../player.h"
#include "../enemy.h"
#include "../eshot.h"
#include "../effect.h"
#include "../psearch.h"
#include "../sound.h"


#define PALET_MAIN	0x0600

#define wabs(x) ((x) >= 0 ? (short) (x) : (short) -(x))
#define abs(x)  ((x) >= 0 ? (int) (x) : (int) -(x))

enum {
	TO_LEFT, TO_CENTER, TO_RIGHT
};


/* ֐vg^Cv錾 */
static short EnemyMoveSearchZ2 (ENEMY *);
static void EnemyFreeSearchZ2 (ENEMY *);


/* [` */
void EnemyAllocSearchZ2 (ENEMY * p)
{
	signed short x = SHORT_LX;

    /* ̃URɊւĂ͂wW͒S̋ */
    /* ɃvC[̔ΑɌ */
	if (player->x < 144) {
		p->lx = (player->x + x) * 65536;
		p->vx = 16384;
	} else {
		p->lx = (player->x - x) * 65536;
		p->vx = -16384;
	}
	p->vy = 4 * 65536;

	p->angle = 64;
	p->pt = obj_searchz + ((p->angle) >> 3);
	p->info = PALET_MAIN | PRIORITY_ZAKO;
	p->hit_sx = 12;
	p->hit_sy = 12;
	p->hp = 1;		/* ϋv */
	p->damage = 0;
	p->damage_mode = DAMAGE_THROUGH;

	p->func_enemy_move = EnemyMoveSearchZ2;
	p->func_enemy_free = EnemyFreeSearchZ2;

    /* RA֘A */
	p->core_info = PALET_CORE_RED | PRIORITY_ZAKO;
	p->core_pt = sp_core + 1;

	p->m_work = 0;
	p->m_work2 = 0;
	p->m_work4 = 0;		/* Pڋ߂ */
}



/* ړ[` */
/* ԂlFOȂ */
static short EnemyMoveSearchZ2 (ENEMY * p)
{
    /* x𑫂ďʃ[hiŒ萮jo */
	p->x = (p->lx += p->vx) >> 16;
	p->y = (p->ly += p->vy) >> 16;

	switch (p->m_work) {

	    /* ܂˂ł */
	case 0:
		if (p->m_work2++ > 16) {
			p->m_work++;
			p->m_work2 = 0;
		}
		break;

	    /*  */
	case 1:
		p->vy -= 32768;
		if (p->vy <= 32768) {
			p->m_work++;
			p->m_work2 = 0;
			p->m_work3 = 0;
			p->s_work = 0;
		}
		break;

	    /* ^ */
	case 2:
		switch (p->m_work2++) {
		case 0:
			if (wabs (SHORT_LX - player->x) < 16) {
				p->m_work4 = TO_CENTER;
			} else {
				if (SHORT_LX < player->x)
					p->m_work4 = TO_RIGHT;	/* E֐i */
				else
					p->m_work4 = TO_LEFT;	/* ֐i */
			}
			break;
		case 30:
			p->m_work2 = 0;
			break;
		default:
			switch (p->m_work4) {
			case TO_CENTER:
				if (p->vx < 2048)
					p->vx += 2048;
				else
					p->vx -= 2048;
				if (p->vy <= 1 * 65536)
					p->vy += 2048;
				if (p->angle != 64) {
					if (p->angle > 64)
						p->angle--;
					else
						p->angle++;
				}
				p->pt = obj_searchz + ((p->angle) >> 3);
				break;
			case TO_RIGHT:
#define INTERVAL2	50
#define SPEED_SHOT2	6
			    /* E֐iގ */
				if (p->angle > 64 - 12)
					p->angle--;
				p->pt = obj_searchz + ((p->angle) >> 3);
				if (p->vx < 65536)
					p->vx += 4096;
				if (p->s_work++ > INTERVAL2) {
					p->s_work = 0;
					if ((wabs (player->x - p->x) + wabs (player->y - p->y)) > 96) {
						EshotAlloc (ESHOT_NRG02, p->x, p->y, SPEED_SHOT2, psearch (p->x, p->y), 0);
						SoundSetSE (SE_ESHOT);	/* GVbg */
					}
				}
				break;
			case TO_LEFT:
			    /* ֐iގ */
				if (p->angle < 64 + 12)
					p->angle++;
				p->pt = obj_searchz + ((p->angle) >> 3);
				if (p->vx > -65536)
					p->vx -= 4096;
				if (p->s_work++ > INTERVAL2) {
					p->s_work = 0;
					if ((wabs (player->x - p->x) + wabs (player->y - p->y)) > 96) {
						EshotAlloc (ESHOT_NRG02, p->x, p->y, SPEED_SHOT2, psearch (p->x, p->y), 0);
						SoundSetSE (SE_ESHOT);	/* GVbg */
					}
				}
				break;
			}
			break;
		}
		break;
	default:
		break;
	}

    /* ʊOɏo */
	if ((p->m_work > 0)
	    && ((SHORT_LY < -32) || (SHORT_LY > 256 + 32)
		|| (SHORT_LX < -32) || (SHORT_LX > 256 + 32)))
		return (-1);	/*  */


    /* O_[W󂯂Ȃ */
	if (p->damage) {
		p->damage = 0;
		EffectAlloc (EFFECT_EXPLZAKO, 0, p->x, p->y);	/* p^[o */
		EffectAlloc (EFFECT_POINTS, points_table[p->shot_count], p->x, p->y);	/* _o */
		SoundSetSE (SE_EXPL);	/* UR */
		return (-1);
	}
	xobj_set_st (p);	/* \ */

    /* RA̕\ */
	p->core_x = p->x - 8;
	p->core_y = p->y - 8;
	xsp_set_st (&(p->core_x));

	return (0);
}



/* [` */
static void EnemyFreeSearchZ2 (ENEMY * p)
{
}
